/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2010 Gabriele Dini Ciacci <dark.schneider@iol.it>
    Based on a code from Luigi Quartapelle and Massimo Biava

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

#ifndef U2D_LOAD_UMESH2D_H
#define	U2D_LOAD_UMESH2D_H

#include <string>
#include <stdio.h>
#include <fstream>
#include <iostream>

#include "u2d_mesh.h"
#include "exceptions.h"

using namespace std;

class u2d_Load_Umesh2d {
public:
    u2d_Load_Umesh2d(string path, string probname, bool reverse = false);
    ~u2d_Load_Umesh2d();
    u2d_Mesh *getMesh();
    void destoryMesh(u2d_Mesh *mesh);

    
private:
    void open_umesh2d_file();
    void close_umesh2d_file();
    void parse_umesh2d_file();
    void parse_grid_size() throw (u2d_Parse_Error_Exception &);
    void parse_nodes_size() throw (u2d_Parse_Error_Exception &);
    void parse_grid();
    void parse_nodes();
    string grid_filename;
    string nodes_filename;
    ifstream grid_file;
    ifstream nodes_file;
    u2d_Mesh *mesh;
    int d_elem_n;
    int b_elem_n;
    int d_nodes_n;
    int b_nodes_n;
    int spatial_dim;
};







#endif	/* U2D_LOAD_UMESH2D_H */

