/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2010 Gabriele Dini Ciacci <dark.schneider@iol.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on April 13, 2010, 6:05 PM
 */

#ifndef _U2D_LOAD_VECTOR_H
#define	_U2D_LOAD_VECTOR_H

#include "boost/numeric/mtl/mtl.hpp"
#include "exceptions.h"

using namespace std;
using namespace mtl;

class u2d_LoadValues {
public:
    u2d_LoadValues(string _filename, bool _lineonesize = true, size_t _suggested_size = 0);
    virtual ~u2d_LoadValues();
    bool lineonesize;
    int suggested_size;
    ifstream filestream;
private:
    void openValuesFile();
    void closeValuesFile();
    virtual void parseValuesFile() throw (u2d_Parse_Error_Exception &) = 0;
    string filename;



};

#endif	/* _U2D_LOAD_VECTOR_H */

