/* 

    umesh2dgui, a GUI for umesh2d grid generator 

    Copyright (C) 2007 Gabriele Dini Ciacci

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef U2D_DISPLAY_SET_H
#define U2D_DISPLAY_SET_H

#include <GL/gl.h>
#include <vector>

using namespace std;

class u2d_Display_Set {
 public:
  u2d_Display_Set();
  ~u2d_Display_Set();

  void Set_Coord_Per_Vertex(GLint m_coord_per_vertex);
  GLint Get_Coord_Per_Vertex();
  void Push_Coord(GLfloat a);
  void Push_Coord(GLfloat a, GLfloat b);
  void Push_Coord(GLfloat a, GLfloat b, GLfloat c);
  GLsizei Get_Vertex_Count();
  GLfloat *Get_Vertex_Array();

  void Set_Coord_Per_Topology(GLint m_coord_per_topology);
  GLint Get_Coord_Per_Topology();
  void Push_Topology_Coord(GLfloat a);
  void Push_Topology_Coord(GLfloat a, GLfloat b);
  void Push_Topology_Coord(GLfloat a, GLfloat b, GLfloat c);
  GLsizei Get_Topology_Count();
  GLfloat *Get_Topology_Array();
  


  GLuint display_list;
  GLenum vertex_type;
  GLenum topology_type;
  GLint red;
  GLint green;
  GLint blue;
  GLfloat line_width;

 private:
  GLint coord_per_vertex;
  GLint coord_per_topology;

  vector<GLfloat> vertex_array;
  vector<GLfloat> topology;
};


#endif
